#include <bits/stdc++.h>
using namespace std;

const long long MX=1e6+10;
const long long INF=1e18;

long long a1,a2,a3,ans=INF;
long long a[MX],pr[MX],ms[MX];
long long n;

int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    cin>>n;

    for(long long i=1;i<=n;i++)
    {
        cin>>a[i];
        pr[i]=pr[i-1]+a[i];
    }

    long long ob=pr[n]/3;

    for(long long i=1,j=0;i<=n;i++)
    {
        while(pr[i]-pr[j]>ob)
        {
            j++;
        }

        if(pr[i]-pr[j]==ob)
        {
            ms[i]=j;
        }
        else
        {
            ms[i]=n+1;
        }
    }
    ms[n+1]=ms[0]=n+1;

    for(long long i=1;i<=n;i++)
    {
        if(ms[ms[i]]==n+1)
        {
            continue;
        }

        cout<<"0\n"<<ms[ms[i]]+1<<" "<<ms[i]+1<<" "<<i+1<<"\n";
        return 0;
    }

    return 0;
}
